/*	Blowfish Encryption Plugin for Back Orifice 2000    
	Copyright (C) 1999, talis 

	parts of this module are taken from various sample modules from
	dildog(structure, plugin archicture), from Maw~(IDEA module 
	structure and layout).  Code for some of the blowfish algoritms
	was gleaned from studying the blowfish encryption bits from 
	ssleay, openbsd, and from counterpane

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

	The author of this program may be contacted at talis@millcomm.com. 
*/
#ifndef __INC_BOBLOWFISH_H
#define __INC_BOBLOWFISH_H

#include<windows.h>
#include<plugins.h>
#include<bocomreg.h>
#include<auth.h>
#include<iohandler.h>
#include<encryption.h>

// ---------------- Global Linkage Variables -----------------
extern CEncryptionHandler				*g_pEncHandler;
extern CIOHandler						*g_pIOHandler;
extern CAuthHandler						*g_pAuthHandler;
extern TYPEOF_RegisterCommand			*RegisterCommand;
extern TYPEOF_UnregisterCommand			*UnregisterCommand;
extern TYPEOF_RegisterClientMenu		*RegisterClientMenu;
extern TYPEOF_UnregisterClientMenu		*UnregisterClientMenu;
extern TYPEOF_IssueAuthCommandRequest	*IssueAuthCommandRequest;
extern TYPEOF_IssueAuthCommandReply		*IssueAuthCommandReply;
extern TYPEOF_ConnectAuthSocket			*ConnectAuthSocket;
extern TYPEOF_ListenAuthSocket			*ListenAuthSocket;
extern TYPEOF_InteractiveConnect		*InteractiveConnect;
extern TYPEOF_InteractiveListen 		*InteractiveListen;

// ------------- Function Implementations ------------------

extern HINSTANCE g_hInstance;
extern char g_szBlowfishOptions[];
extern BOOL g_bActive;
extern ENCRYPTION_ENGINE *GetBlowfishEngine(void);
#endif


